Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5213)
@@ -11,28 +11,60 @@
 !> @details
 !>    define type TVAR:<br/>
-!>    TYPE(TVAR) :: tl_var<br/>
+!> @code
+!>    TYPE(TVAR) :: tl_var
+!> @endcode
 !>
-!>    the variable value will always be 4D table of real(8).<br/>
+!>    @note the variable value inside structure will always be 4D array of real(8).<br/>
 !>    However the variable value could be initialised with
-!>    table of real(4), real(8), integer(4) or integer(8)
+!>    array of real(4), real(8), integer(4) or integer(8).
 !>        
 !>    to initialise a variable structure:<br/>
-!>    tl_var=var_init( cd_name, [value,] [id_start, [id_count,]] [td_dim,] [td_att] )
+!> @code
+!>    tl_var=var_init( cd_name, [value,] [id_start, [id_count,]] [id_type,] [td_dim,] [td_att]... )
+!> @endcode
 !>       - cd_name is the variable name
-!>       - value is a 4D table ordered as ('x','y','z','t') (optional)
-!>          (real(4), real(8), integer(4) or integer(8)
-!>       - id_start is a integer(4) 1D table of index from which the data 
-!>          values will be read (optional)
-!>       - id_count is a integer(4) 1D table of the number of indices selected
-!>          along each dimension (optional)
-!>       - td_dim is the table of dimension structure (optional)
-!>       - td_att is the table of attribute structure (optional)
+!>       - value is a 1D,2D,3D or 4D array, see var_init for more information [optional]
+!>       - id_start is a integer(4) 1D array of index from which the data 
+!>          values will be read [optional]
+!>       - id_count is a integer(4) 1D array of the number of indices selected
+!>          along each dimension [optional]
+!>       - id_type is the type of the variable to be used [optional]
+!>       - td_dim is the array of dimension structure [optional]
+!>       - td_att is the array of attribute structure [optional]
+!>    Note:<br/>
+!>       - others optionals arguments could be added, see var_init.
+!>       - to put variable 0D, use td_dim with all dimension unused
+!> (td_dim(:)%l_use=.FALSE.)
+!>    
+!>    to print information about variable structure:<br/>
+!> @code
+!>    CALL var_print(td_var [,ld_more])
+!> @endcode
+!>       - td_var is the variable structure
+!>       - ld_more to print more infomration about variable
 !>
-!>    to print information about variable structure:<br/>
-!>    CALL var_print(tl_var)
+!>    to clean variable structure:<br/>
+!> @code
+!>    CALL var_clean(tl_var)
+!> @endcode
+!>
+!>    to copy variable structure in another one (using different memory cell):<br/>
+!> @code
+!>    tl_var2=var_copy(tl_var1) 
+!> @endcode
+!>    @note as we use pointer for the value array of the variable structure,
+!>    the use of the assignment operator (=) to copy variable structure 
+!>    create a pointer on the same array. 
+!>    This is not the case with this copy function.
 !>
 !>    to get variable name:<br/>
 !>    - tl_var\%c_name
-!>    
+!>
+!>    to get grid point of the variable:<br/>
+!>    - tl_var\%c_point
+!>
+!>    to get EW overlap:<br/>
+!>    - tl_var\%i_ew
+!>
 !>    to get variable value:<br/>
 !>    - tl_var\%d_value(:,:,:,:)
@@ -42,5 +74,5 @@
 !>    - tl_var\%i_type
 !>
-!>    to get variable id (affected when variable will be added to a file):<br/>
+!>    to get variable id (read from a file):<br/>
 !>    - tl_var\%i_id
 !>
@@ -49,14 +81,15 @@
 !>    - tl_var\%i_ndim
 !>
-!>    to get the table of dimension structure (4 elts) associated to the
+!>    to get the array of dimension structure (4 elts) associated to the
 !>    variable:<br/>
 !>    - tl_var\%t_dim(:)
 !>
 !>    Variable attributes<br/>
-!>    attribue value are always character or real(8) 1D table.<br/>
+!>    @note attribue value are always character or real(8) 1D array.<br/>
+!>
 !>    to get the number of attributes of the variable:<br/>
 !>    - tl_var\%i_natt
 !>
-!>    to get the table of attribute structure associated to the
+!>    to get the array of attribute structure associated to the
 !>    variable:<br/>
 !>    - tl_var\%t_att(:)
@@ -66,6 +99,12 @@
 !>    - tl_var\%c_stdname
 !>
+!>    to get variable longname:<br/>
+!>    - tl_var\%c_longname
+!>
 !>    to get variable units:<br/>
 !>    - tl_var\%c_units
+!>
+!>    to get variable axis:<br/>
+!>    - tl_var\%c_axis
 !>
 !>    to get variable scale factor:<br/>
@@ -79,50 +118,169 @@
 !>
 !>    to add value to a variable structure:<br/>
-!>    CALL var_add_value(tl_var, value, [id_start, [id_count]]) 
-!>       - value : 4D table of value (real(4), real(8), integer(4), integer(8))
-!>       - id_start : 1D table of the index in the variable from which the data
+!> @code
+!>    CALL var_add_value(tl_var, value, [id_type,] [id_start, [id_count]]) 
+!> @endcode
+!>       - value : 4D array of value (real(4), real(8), integer(1), integer(2), integer(4), integer(8))
+!>       - id_type is the type of the variable to be used (default is the type
+!> of array value)
+!>       - id_start : 1D array of the index in the variable from which the data
 !>       values will be read (integer(4), optional)
-!>       - id_count : 1D table of the number of indices selected along each 
+!>       - id_count : 1D array of the number of indices selected along each 
 !>       dimension (integer(4), optional)
 !>
-!>    to add one attribute to a variable structure:<br/>
+!>    to add attribute to a variable structure:<br/>
+!> @code
 !>    CALL var_add_att(tl_var, td_att)
-!>       - td_att is an attribute structure 
+!> @endcode
+!>       - td_att is an attribute structure, or array of attribute structure 
 !>
-!>    to add one dimension to a variable structure:<br/>
+!>    to add dimension to a variable structure:<br/>
+!> @code
 !>    CALL var_add_dim(tl_var, td_dim)
-!>       - td_dim is a dimension structure
+!> @endcode
+!>       - td_dim is a dimension structure, or array of dimension structure
 !> 
 !>    to delete value of a variable structure:<br/>
+!> @code
 !>    CALL var_del_value(tl_var)
+!> @endcode
 !>
 !>    to delete one attribute of a variable structure:<br/>
+!> @code
 !>    CALL var_del_att(tl_var, td_att)
+!> @endcode
 !>       - td_att is an attribute structure 
+!> or
+!> @code
+!>    CALL var_del_att(tl_var, cd_name)
+!> @endcode
+!>       - cd_name is attribute name 
 !>
 !>    to delete one dimension of a variable structure:<br/>
+!> @code
 !>    CALL var_del_dim(tl_var, td_dim)
+!> @endcode
 !>       - td_dim is a dimension structure
 !>
 !>    to overwrite one attribute structure in variable structure:<br/>
+!> @code
 !>    CALL var_move_att(tl_var, td_att)
+!> @endcode
 !>       - td_att is an attribute structure
 !>
 !>    to overwrite one dimension structure in variable structure:<br/>
+!> @code
 !>    CALL var_move_dim(tl_var, td_dim)
+!> @endcode
 !>       - td_dim is a dimension structure
 !>
+!>    to get the mask of a variable strucutre, (based on its FillValue):<br/>
+!> @code
+!>    mask(:,:)=var_get_mask(tl_var)
+!> @endcode
+!>
+!>    to change FillValue to standard NETCDF Fill Value:<br/>
+!> @code
+!>    CALL  var_chg_FillValue(tl_var, [dd_fill])
+!> @endcode
+!>       - dd_fill is the FillValue to be used [optional]
+!>
+!>    to concatenate two variables:<br/>
+!> @code
+!>    tl_var=var_concat(tl_var1, tl_var2, [DIM])
+!> @endcode
+!>       - tl_var1 : variable structure 
+!>       - tl_var2 : variable structure 
+!>       - DIM : number of the dimension following which concatenate (1=>I, 2=>J, 3=>Z, 4=>T) [optional, default=4]
+!>
+!>    to forced min and max value of a variable:<br/>
+!>    define min and max value of the variable:<br/>
+!>    tl_var\%d_min=min<br/>
+!>    tl_var\%d_max=max<br/>
+!>    then<br/>
+!> @code
+!>    CALL  var_limit_value( tl_var )
+!> @endcode
+!>       - min and max : real(8) value
+!>
+!>    to get the biggest dimensions use in a array of variable:<br/>
+!> @code
+!>    tl_dim(:)=var_max_dim(tl_var(:))
+!> @endcode
+!>       - tl_var(:) : array of variable structure
+!>       - tl_dim(:) : array (4 elts) of dimension structure
+!>
+!>    to reorder dimension of a variable (default 'x','y','z','t'):<br/>
+!> @code
+!>    CALL var_reorder( td_var, cd_dimorder )
+!> @endcode
+!>       - td_var is variable structure
+!>       - cd_dimorder string character(LEN=4) of dimension order to be used (example:
+!> 'yxzt') [optional]
+!>
+!>    to get variable index, in an array of variable structure:<br/>
+!> @code
+!>   il_index=var_get_index( td_var, cd_name )
+!> @endcode
+!>    - td_var array of variable structure
+!>    - cd_name variable name
+!> 
+!>    to get variable id, read from a file:<br/>
+!>@code
+!>  il_id=var_get_id( td_var, cd_name )
+!>@endcode
+!>    - td_var array of variable structure
+!>    - cd_name variable name
+!>
+!>    to get free variable unit in an array of variable structure:<br/>
+!>@code
+!>  il_unit=var_get_unit(td_var)
+!>@endcode
+!>    - td_var array of variable structure
+!>
+!>    to convert time variable structure in date structure:<br/>
+!>@code
+!>   tl_date=var_to_date(td_var) 
+!>@endcode
+!>    - td_var is time variable structure
+!>    - tl_date is date structure
+!>
+!>    to read matrix value from character string in namelist
+!>@code
+!>    CALL var_read_matrix(td_var, cd_matrix)
+!>@endcode
+!>    - td_var is variable structure
+!>    - cd_matrix is matrix value
+!>
+!>    to read variable configuration file ('variable.cfg') and fill global array
+!> of variable structure:<br/>
+!>@code
+!>    CALL var_def_extra( cd_file )
+!>@endcode
+!>    - cd_file is filename
+!>
+!>    to add variable information get from namelist, in global array of variable 
+!> structure:
+!>@code
+!>    CALL var_chg_extra( cd_varinfo )
+!>@endcode
+!>    - cd_varinfo is variable information from namelist
+!>
+!>    to check variable dimension expected, as defined in file 'variable.cfg':<br/>
+!>@code
+!>    CALL var_check_dim( td_var )
+!>@endcode
+!>    - td_var is variable structure
+!> 
 !> @author
 !> J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
+!> @date November, 2013 - Initial Version
+!> @date September, 2014
+!>  - add var_reorder
+!> @date November, 2014 
+!> - Fix memory leaks bug
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!> @todo
-!> - manage ew_wrap in structure
-!> - manage c_point in structure
-!> - think about create init for 0D 1D 2D 3D input table
-!> - creer module cfg qui lit et def tg_varcfg (pb var_get_extra appele ds
-!> var_init)
 !----------------------------------------------------------------------
 MODULE var
@@ -130,10 +288,10 @@
    USE global                          ! global variable
    USE kind                            ! F90 kind parameter
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
+   USE date                            ! date manager
    USE fct                             ! basic useful function
    USE att                             ! attribute manager
    USE dim                             ! dimension manager
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
@@ -141,90 +299,97 @@
    PUBLIC :: TVAR        !< variable structure
 
-   PUBLIC :: tg_varextra !< table of variable structure with extra information.
+   PUBLIC :: tg_varextra !< array of variable structure with extra information.
 
    ! function and subroutine
-   PUBLIC :: ASSIGNMENT(=) !< copy variable structure
-   PUBLIC :: var_init      !< initialize variable structure
-   PUBLIC :: var_print     !< print variable information
-   PUBLIC :: var_clean     !< clean variable structure
-   PUBLIC :: var_get_id    !< return the variable id, from a table of variable structure 
-   PUBLIC :: var_add_value !< add table of value in variable structure
-   PUBLIC :: var_add_att   !< add attribute structure in variable structure
-   PUBLIC :: var_add_dim   !< add dimension structure in variable structure
-   PUBLIC :: var_del_value !< delete table of value of variable structure
-   PUBLIC :: var_del_att   !< delete one attribute structure of variable structure
-   PUBLIC :: var_del_dim   !< delete one dimension structure of variable structure
-   PUBLIC :: var_move_att  !< overwrite one attribute structure in variable structure
-   PUBLIC :: var_move_dim  !< overwrite one dimension structure in variable structure 
-   PUBLIC :: var_get_mask  !< return the mask of variable
-   PUBLIC :: var_chg_FillValue  !< change FillValue to standard NETCDF Fill Value
-   PUBLIC :: var_def_extra  !< read variable configuration file, and save extra information.
-   PUBLIC :: var_chg_extra  !< read variable namelist information, and modify extra information.
-   PUBLIC :: var_read_matrix !<  
-!   PUBLIC :: var_match_file !< read variable namelist information, and modify extra information.
-   PUBLIC :: var_max_dim    !< get table of maximum dimension use
-   PUBLIC :: var_concat       !< concatenate two variables
-   PUBLIC :: var_limit_value  !< forced min and max value
-   PUBLIC :: var_check_dim    !< check variable dimension expected
-
-!   PUBLIC :: var_ended     !< deallocate global variable
-
-   PRIVATE :: var__add_value_dp  !< add table of value real(8) in variable structure
-   PRIVATE :: var__add_value_rp  !< add table of value real(4) in variable structure
-   PRIVATE :: var__add_value_i1  !< add table of value integer(1) in variable structure
-   PRIVATE :: var__add_value_i2  !< add table of value integer(2) in variable structure
-   PRIVATE :: var__add_value_i4  !< add table of value integer(4) in variable structure
-   PRIVATE :: var__add_value_i8  !< add table of value integer(8) in variable structure
-   PRIVATE :: var__init          !< initialse variable structure without table of value
-   PRIVATE :: var__init_dp       !< initialse variable structure with real(8) 4D table of value
-   PRIVATE :: var__init_1D_dp    !< initialse variable structure with real(8) 1D table of value
-   PRIVATE :: var__init_2D_dp    !< initialse variable structure with real(8) 2D table of value
-   PRIVATE :: var__init_3D_dp    !< initialse variable structure with real(8) 3D table of value
-   PRIVATE :: var__init_sp       !< initialse variable structure with real(4) 4D table of value
-   PRIVATE :: var__init_1D_sp    !< initialse variable structure with real(4) 1D table of value
-   PRIVATE :: var__init_2D_sp    !< initialse variable structure with real(4) 2D table of value
-   PRIVATE :: var__init_3D_sp    !< initialse variable structure with real(4) 3D table of value
-   PRIVATE :: var__init_i1       !< initialse variable structure with integer(1) 4D table of value
-   PRIVATE :: var__init_1D_i1    !< initialse variable structure with integer(1) 1D table of value
-   PRIVATE :: var__init_2D_i1    !< initialse variable structure with integer(1) 2D table of value
-   PRIVATE :: var__init_3D_i1    !< initialse variable structure with integer(1) 3D table of value
-   PRIVATE :: var__init_i2       !< initialse variable structure with integer(2) 4D table of value
-   PRIVATE :: var__init_1D_i2    !< initialse variable structure with integer(2) 1D table of value
-   PRIVATE :: var__init_2D_i2    !< initialse variable structure with integer(2) 2D table of value
-   PRIVATE :: var__init_3D_i2    !< initialse variable structure with integer(2) 3D table of value
-   PRIVATE :: var__init_i4       !< initialse variable structure with integer(4) 4D table of value
-   PRIVATE :: var__init_1D_i4    !< initialse variable structure with integer(4) 1D table of value
-   PRIVATE :: var__init_2D_i4    !< initialse variable structure with integer(4) 2D table of value
-   PRIVATE :: var__init_3D_i4    !< initialse variable structure with integer(4) 3D table of value
-   PRIVATE :: var__init_i8       !< initialse variable structure with integer(8) 4D table of value
-   PRIVATE :: var__init_1D_i8    !< initialse variable structure with integer(8) 1D table of value
-   PRIVATE :: var__init_2D_i8    !< initialse variable structure with integer(8) 2D table of value
-   PRIVATE :: var__init_3D_i8    !< initialse variable structure with integer(8) 3D table of value
-   PRIVATE :: var__add_dim_unit  !< add one dimension structure in variable structure
-   PRIVATE :: var__add_dim_tab   !< add a table of dimension structure in variable structure
-   PRIVATE :: var__add_att_unit  !< add one attribute structure in variable structure
-   PRIVATE :: var__add_att_tab   !< add a table of attribute structure in variable structure
-   PRIVATE :: var__add_dim       !< add a dimension structure in a variable structure.
-   PRIVATE :: var__add_value     !< add a 4D table of double value in a variable structure.
-   PRIVATE :: var__copy_unit     !< copy variable structure
-   PRIVATE :: var__copy_tab      !< copy variable structure
-   PRIVATE :: var__get_extra     !< add extra information in variable structure
-   PRIVATE :: var__concat_i      !< concatenate varibales in i-direction
-   PRIVATE :: var__concat_j      !< concatenate varibales in j-direction
-   PRIVATE :: var__concat_k      !< concatenate varibales in k-direction
-   PRIVATE :: var__concat_l      !< concatenate varibales in l-direction
-   PRIVATE :: var__get_max       !< get maximum value from namelist 
-   PRIVATE :: var__get_min       !< get minimum value from namelist
-   PRIVATE :: var__get_interp    !< get interpolation method from namelist
-   PRIVATE :: var__get_extrap    !< get extrapolation method from namelist
-   PRIVATE :: var__get_filter    !< get filter method from namelist
-
-   !> @struct TVAR
-   TYPE TVAR
+   PUBLIC :: var_init          !< initialize variable structure
+   PUBLIC :: var_print         !< print variable information
+   PUBLIC :: var_clean         !< clean variable structure
+   PUBLIC :: var_copy          !< copy variable structure
+   PUBLIC :: var_add_value     !< add array of value in variable structure
+   PUBLIC :: var_add_att       !< add attribute structure in variable structure
+   PUBLIC :: var_add_dim       !< add dimension structure in variable structure
+   PUBLIC :: var_del_value     !< delete array of value of variable structure
+   PUBLIC :: var_del_att       !< delete one attribute structure of variable structure
+   PUBLIC :: var_del_dim       !< delete one dimension structure of variable structure
+   PUBLIC :: var_move_att      !< overwrite one attribute structure in variable structure
+   PUBLIC :: var_move_dim      !< overwrite one dimension structure in variable structure 
+   PUBLIC :: var_get_mask      !< return the mask of variable
+   PUBLIC :: var_chg_FillValue !< change FillValue to standard NETCDF Fill Value
+   PUBLIC :: var_concat        !< concatenate two variables
+   PUBLIC :: var_limit_value   !< forced min and max value
+   PUBLIC :: var_max_dim       !< get array of maximum dimension use
+   PUBLIC :: var_reorder       !< reorder table of value in variable structure
+   PUBLIC :: var_get_index     !< return the variable index, in an array of variable structure 
+   PUBLIC :: var_get_id        !< return the variable id, read from a file 
+   PUBLIC :: var_get_unit      !< get free variable unit in an array of variable structure
+   PUBLIC :: var_to_date       !< convert time variable structure in date structure
+   PUBLIC :: var_read_matrix   !< read matrix value from character string in namelist 
+   PUBLIC :: var_def_extra     !< read variable configuration file, and save extra information.
+   PUBLIC :: var_chg_extra     !< read variable namelist information, and modify extra information.
+   PUBLIC :: var_check_dim     !< check variable dimension expected
+
+   PRIVATE :: var__init          ! initialize variable structure without array of value
+   PRIVATE :: var__init_dp       ! initialize variable structure with real(8) 4D array of value
+   PRIVATE :: var__init_1D_dp    ! initialize variable structure with real(8) 1D array of value
+   PRIVATE :: var__init_2D_dp    ! initialize variable structure with real(8) 2D array of value
+   PRIVATE :: var__init_3D_dp    ! initialize variable structure with real(8) 3D array of value
+   PRIVATE :: var__init_sp       ! initialize variable structure with real(4) 4D array of value
+   PRIVATE :: var__init_1D_sp    ! initialize variable structure with real(4) 1D array of value
+   PRIVATE :: var__init_2D_sp    ! initialize variable structure with real(4) 2D array of value
+   PRIVATE :: var__init_3D_sp    ! initialize variable structure with real(4) 3D array of value
+   PRIVATE :: var__init_i1       ! initialize variable structure with integer(1) 4D array of value
+   PRIVATE :: var__init_1D_i1    ! initialize variable structure with integer(1) 1D array of value
+   PRIVATE :: var__init_2D_i1    ! initialize variable structure with integer(1) 2D array of value
+   PRIVATE :: var__init_3D_i1    ! initialize variable structure with integer(1) 3D array of value
+   PRIVATE :: var__init_i2       ! initialize variable structure with integer(2) 4D array of value
+   PRIVATE :: var__init_1D_i2    ! initialize variable structure with integer(2) 1D array of value
+   PRIVATE :: var__init_2D_i2    ! initialize variable structure with integer(2) 2D array of value
+   PRIVATE :: var__init_3D_i2    ! initialize variable structure with integer(2) 3D array of value
+   PRIVATE :: var__init_i4       ! initialize variable structure with integer(4) 4D array of value
+   PRIVATE :: var__init_1D_i4    ! initialize variable structure with integer(4) 1D array of value
+   PRIVATE :: var__init_2D_i4    ! initialize variable structure with integer(4) 2D array of value
+   PRIVATE :: var__init_3D_i4    ! initialize variable structure with integer(4) 3D array of value
+   PRIVATE :: var__init_i8       ! initialize variable structure with integer(8) 4D array of value
+   PRIVATE :: var__init_1D_i8    ! initialize variable structure with integer(8) 1D array of value
+   PRIVATE :: var__init_2D_i8    ! initialize variable structure with integer(8) 2D array of value
+   PRIVATE :: var__init_3D_i8    ! initialize variable structure with integer(8) 3D array of value
+   PRIVATE :: var__print_unit ! print information on one variable
+   PRIVATE :: var__print_arr  ! print information on a array of variables
+   PRIVATE :: var__clean_unit    ! clean variable structure
+   PRIVATE :: var__clean_arr_1D  ! clean 1D array of variable structure
+   PRIVATE :: var__clean_arr_2D  ! clean 2D array of variable structure
+   PRIVATE :: var__clean_arr_3D  ! clean 3D array of variable structure
+   PRIVATE :: var__add_value_dp  ! add array of value real(8) in variable structure
+   PRIVATE :: var__add_value_rp  ! add array of value real(4) in variable structure
+   PRIVATE :: var__add_value_i1  ! add array of value integer(1) in variable structure
+   PRIVATE :: var__add_value_i2  ! add array of value integer(2) in variable structure
+   PRIVATE :: var__add_value_i4  ! add array of value integer(4) in variable structure
+   PRIVATE :: var__add_value_i8  ! add array of value integer(8) in variable structure
+   PRIVATE :: var__add_att_unit  ! add one attribute structure in variable structure
+   PRIVATE :: var__add_att_arr   ! add a array of attribute structure in variable structure
+   PRIVATE :: var__del_att_name  ! delete one attribute given attribute name
+   PRIVATE :: var__del_att_str   ! delete one attribute given attribute structure
+   PRIVATE :: var__add_dim_unit  ! add one dimension structure in variable structure
+   PRIVATE :: var__add_dim_arr   ! add a array of dimension structure in variable structure
+   PRIVATE :: var__add_value     ! add a 4D array of real(8) value in a variable structure.
+   PRIVATE :: var__copy_unit     ! copy variable structure
+   PRIVATE :: var__copy_arr      ! copy a array of variable structure
+   PRIVATE :: var__get_extra     ! add extra information in variable structure
+   PRIVATE :: var__concat_i      ! concatenate varibales in i-direction
+   PRIVATE :: var__concat_j      ! concatenate varibales in j-direction
+   PRIVATE :: var__concat_k      ! concatenate varibales in k-direction
+   PRIVATE :: var__concat_l      ! concatenate varibales in l-direction
+   PRIVATE :: var__get_max       ! get maximum value from namelist 
+   PRIVATE :: var__get_min       ! get minimum value from namelist
+   PRIVATE :: var__get_interp    ! get interpolation method from namelist
+   PRIVATE :: var__get_extrap    ! get extrapolation method from namelist
+   PRIVATE :: var__get_filter    ! get filter method from namelist
+
+   TYPE TVAR   !< variable structure
 
       CHARACTER(LEN=lc) :: c_name  = ''  !< variable name
-      CHARACTER(LEN=lc) :: c_point = '' !< type of grid point
+      CHARACTER(LEN=lc) :: c_point = 'T' !< ARAKAWA C-grid point name (T,U,V,F)
       INTEGER(i4)       :: i_id = 0      !< variable id
-      INTEGER(i4)       :: i_ew = 0      !< east-west overlap
+      INTEGER(i4)       :: i_ew = -1     !< east-west overlap
 
       REAL(dp)   , DIMENSION(:,:,:,:), POINTER :: d_value => NULL() !< variable value
@@ -237,5 +402,7 @@
       TYPE(TDIM), DIMENSION(ip_maxdim)  :: t_dim           !< variable dimension
       
-      ! highlight some attribute
+      LOGICAL           :: l_file = .FALSE.  !< variable read in a file
+
+      ! highlight some attributes
       CHARACTER(LEN=lc) :: c_stdname  = ''!< variable standard name
       CHARACTER(LEN=lc) :: c_longname = ''!< variable long name
@@ -245,6 +412,6 @@
       REAL(dp)          :: d_ofs = 0.           !< offset
       REAL(dp)          :: d_fill= 0.           !< fill value     ! NF90_FILL_DOUBLE 
-      REAL(dp)          :: d_min = dg_fill      !< minimum value 
-      REAL(dp)          :: d_max = dg_fill      !< maximum value 
+      REAL(dp)          :: d_min = dp_fill      !< minimum value 
+      REAL(dp)          :: d_max = dp_fill      !< maximum value 
       
       !!! netcdf4
@@ -256,5 +423,5 @@
 
       !!! dimg
-      INTEGER(i4) :: i_rec = 0 !< record number
+      INTEGER(i4) :: i_rec  = 0 !< record number
 
       CHARACTER(LEN=lc), DIMENSION(2) :: c_interp = '' !< interpolation method
